# py-3parencryptor

This package provides the user using HPE 3PAR Array as their storage on platforms like docker, k8s and openshift a functionality by whuch they can encrypt their passwords present in configurstion file (hpe.conf).

hpe.conf is a configuration file for accessing 3PAR array.

## Downloading the package

Tis package can be downloaded from pip. Use below command for downloading the package.

````
$pip install py-3parencryptor
````

### Pre-requisite and Enviornment
- Linux(CentOS, Ubuntu, Red Hat, etcd)
- Docker installed
- etcd container running
- hpe.conf configured properly on /etc/hpedockerplugin/hpe.conf
- etcd parameters propelry mentioned in hpe.conf

### Usage

When py-3parencryptor is installed on machine. It can be used with the help of hpe3parencryptor command like below.
You have to  use the same passphrase to encrypt all the passwords for a backend.
There can be 4 possible password:
1. hpe3par_password
2. san_password  
3. hpe3par_password for replication array
4. san_password for replication array.

After generating the password replace the password with encrypted one.

````
#hpe3parencryptor -a <passphrase> <password>

Example: 

#hpe3parencryptor -a "@123#" "password"
SUCCESSFUL: Encrypted password: +CB1E8Je1j8=

````
#### Add the encrypted password in /etc/hpedockerplugin/hpe.conf

Use the encrypted password generated by utility as hpe3par_password in hpe.conf 

enable the plugin now

#### Running the utility with -d option
 If user wants to remove the current encrypted password and replace it with plain text or new encrypted password,
user need to delete the current password by using -d option in the utility.

````
# hpe3parencryptor -d
Key Successfully deleted
````
## For Multiple backend

#### Encrypting a specific backend
- When multiple backend present in the configuration file(hpe.conf). User can use the utility to encrypt the password on backend basis.
- With --backend option user can provide the backend for which backend they want to encrypt the passwords.

````
#hpe3parencryptor -a <passphrase> <password> --backend <backend_name>

````
#### Removing encrypted password from a specific backend

Users can remove the encrypted password of a specific backend. Users can use the utility to delete that.
There is an additional optional argument with -d, --backend.

````
# hpe3parencryptor -d --backend <backend_name>

````

#### Note : 
````
If --backend is not used, in both the case (-a and -d), package will take the default backend for performing the operations.
````

